$(document).ready(function () {
  if (Parse.User.current()){
    redirectNonRegularUser(Parse.User.current());
  } else{
    redirectLoggedOutUser();
  }
  $("#username-text").text("(" + Parse.User.current().attributes.username + ")"); 
  $("#tags").tagsinput({
    confirmKeys: [13, 44, 32, 188]
  }); 

  // Scheduled date and time
  $('#datetime12').combodate({
          value: new Date(),
          format:"YYYY-MM-DDTHH:mm:ss",
          template:"DD / MM / YYYY     hh : mm a",
          firstItem: "none",
          roundTime:false,
          minuteStep:1,
          smartDays:true,
          minYear: moment().format("YYYY") ,
          maxYear: (parseInt(moment().format("YYYY")) + 1) 
    }); 

  $("#push-time").change(function(){
      $( "select option:selected").each(function(){
          if($(this).attr("value")=="now"){
              $("#scheduled-details").hide(); 
          }
          if($(this).attr("value")=="scheduled"){ 
              $("#scheduled-details").show();
          } 
      });
  }).change();

  // Time Zone
  var currentTimeZone = moment().format('Z');
  $("#time-zone").append('<option value="'+currentTimeZone+'">'+currentTimeZone+'</option>');
  $("#time-zone").append('<option value="">Local to User');

  // Character count   
  Countable.live(document.getElementById("push-content"), function (counter) {
    console.log(counter);
    $("#count").text(counter.characters);
  })
});

function redirectNonRegularUser(user){
  if (user.attributes.role == "admin") {
    window.location = 'admin.html';
  } 
}

function pushToClients(){

  var iosStatusSelector = "#status-ios";
  var androidStatusSelector = "#status-android";

  // clear status
  $(iosStatusSelector).text( "");
  $(iosStatusSelector).removeAttr("class"); 
  $(androidStatusSelector).text( "");
  $(androidStatusSelector).removeAttr("class"); 

  var isIos = $('#ios-client').is(':checked');
  var isAndroid = $('#android-client').is(':checked');

  if(!isIos && !isAndroid){
    $(iosStatusSelector).attr("class","error"); 
    $(iosStatusSelector).text( "You need to select at least one Device Type");
  }

  if(isIos) { 
    $(iosStatusSelector).removeAttr("class"); 
    $(iosStatusSelector).text( "In progress...");
    push('ios', iosStatusSelector);
  }

  if(isAndroid) { 
    $(androidStatusSelector).removeAttr("class"); 
    $(androidStatusSelector).text( "In progress...");
    push('android', androidStatusSelector);
  }
}

function push(platform, statusSelector) {

  var content = $("#push-content").val();
  var tags = $("#tags").tagsinput('items');
  var options = {
      data: {}
  }

  // Add OS 
  options.where = {}
  options.where.deviceType = platform;
  
  // Add Tags 
  if(tags && tags.length > 0){
    console.log("tags" + tags);
    options.where.channels = {"$in":tags};
  }  

  // Add custom receiver for Android 
  if(platform == "android"){
    options.data.action = "com.talgrace.CUSTOM_NOTIF";
    options.data.content = content;
  } else {
    options.data.alert = content
    options.data.sound = "default"
  }

  // Scheduling Future Push Notifications
  var isScheduled = document.getElementById('isScheduled');
  // if (isScheduled.checked){ 
    if(true){
    options.push_time = ($("#datetime12").combodate("getValue") + $( "#time-zone option:selected" ).val());
  }

  $.ajax({
     url: 'https://api.parse.com/1/push',
     type: 'post',
     data: JSON.stringify(options),
     headers: {
        "X-Parse-Application-Id": Parse.User.current().attributes.appId,
        "X-Parse-REST-API-Key": Parse.User.current().attributes.restKey,
    },
    contentType: 'application/json',
    dataType: 'json',
    error: function(xhr, error){
      $(statusSelector).attr("class","error");  
      $(statusSelector).text(  platform.toUpperCase() + " - " + "Error while sending notification:  " + JSON.parse(xhr.responseText).error);
    },
    success: function (data) {
      console.log(data);
      $(statusSelector).attr("class","success");  
      $(statusSelector).text( platform.toUpperCase() + " - " + "Push sent successfuly");
    }
});
}
